#define IHEDR_Def 1000
#define INDEPDO_Def 1100
#define Indepdo_Ref 1200
#define Indepdo_Lref 1300
#define Lref_created 1350
#define IINDEX_Def 1400 
#define COM_COST 1450

#define Left_Bit 0x01
#define Right_Bit 0x02
#define LR_Bit 0x03

#define Numerator_Bit 0x01
#define Denominator_Bit 0x02
#define ND_Bit 0x03

#define Inmost_indepdo_loop 1500
#define First_stmt_in_indepdo 1510
#define Last_stmt_in_indepdo 1520

#define INSERTED_AFTER_STMT 2000
#define FUTURE_INSERT_AFTER 2030
#define INSERTED_AFTER_STMT_IN 2050

#define OC_INDEX_INIT 2100
#define KEPT_OC_REF 2200
#define KEPT_ARRAY_REF 2250
#define COLLAPSE_NUM 2300
#define INDEPDO_Coef 2400
#define INDEPDO_Have_Oc_Array 2500 
#define Call_Stmt_of_arrayref 2600
#define OLD_STMT 2620
#define STRIDE_GOT 2630
#define CALLED_IN_INDEP 2650
#define INDEPDO_Call_stmt_with_Arrayref 2700
#define Array_Arg_num  2800
#define Array_Arg_dad  2830

#define FUNC_EXP 2840
#define INDEPDO_stmt_with_FUNC 2850

#define BASE_GET_STMT  3000
#define STACK_FREE_STMT 3100

#define SUB_REFED_LOOPVAR 3200
#define LOOPVAR_STK 3220
#define SUB_REFED_INDEXVAR 3250
#define SUB_RANGE 3300
#define REPLACED 3320
#define SUB_ARRAYEXP 3400

#define POTENTIAL_CONDITION_ASSIGN 3350
#define CONDITION_ASSIGN 3310
class Indepdo_header_def:public Forall_header_def{
};
class Indepdo_index_def:public Forall_index_def{
public:
	int loop_cut;  
public:
	Indepdo_index_def();
};
class Indepdo_reference:public forall_reference{
	int ref_attrib;
	int amount_1[2][MAX_ALIGN_DIM];
public:
	SgStatement *body;
	SgExpression *kept;
	int ref_sequence;
	int added_ref_attrib;
	int pre_ref;
	int counter;
	int lhs_counter;
	int pre_sym_ref_num;
	int partitioned_sub_num;
public:
	Indepdo_reference(int,int);
	int get_ref_attrib();
	//int add_ref_attrib(int r_a);
	void add_ref_attrib(int r_a);
	int getAmount(int,int);
	void setAmount(int,int,int);
};

class loop_var{
	SgSymbol *var_sym;
	SgExpression *start;
	SgExpression *end;
	SgExpression *step;
public:
	loop_var(SgForStmt * do_loop);
	loop_var(SgStatement * s);
	SgSymbol *getsymbol();
	SgExpression *get_start();
	SgExpression *get_end();
	SgExpression *get_step();
};

class stack;

class stack{
#define MAX_ELEMENT_NUM   20
	int flag;//if flag is 0 this is a stack of SgExpression
		 //if flag is 1 this is a stack of loop_var
	SgExpression * exp[MAX_ELEMENT_NUM];
	loop_var *lpvar[MAX_ELEMENT_NUM];
	int element_num;
public:
	stack(){ flag=0;element_num =0;};
	stack * copyPtr();
	void push(SgExpression * e);
	void push(loop_var * e);
	void pop();
	SgExpression * get_exp(int i);
	void delete_exp(int i);
	void replace_exp(int i,SgExpression *e);
	loop_var * get_loopvar(int i);
	SgExpression * top_exp();
	loop_var * top_loopvar();
	int elements(){ return element_num ; };
};

#define Shift_Def 1150	

class Shift_def:public Shadow_def{
	int amt[MAX_ALIGN_DIM];
	SgExpression *dim_range[MAX_ALIGN_DIM];
	int dim_count;
public:
	char *str;
	Indepdo_reference *shift_iref;
	int rw_flag;//0:read,1:write
	Shift_def(Org tag):Shadow_def(tag){
		for(int i=0;i<MAX_ALIGN_DIM;i++){
			amt[i]=0;
			dim_range[i]=NULL;
		}
		dim_count=0;
		str="in indepdo";
	};
	void setAmt(int dim,int a){ amt[dim]=a;dim_count++; };
	int getAmt(int dim){ return amt[dim]; };
	void setDimRange(int dim,SgExpression * ddot){ dim_range[dim]= ddot;};
	SgExpression *getDimRange(int dim){ return dim_range[dim];};
	void show(){ 
		printf("%s,dim_num:%d,amount:",str,dim_count);
		for(int i=0;i<dim_count;i++){
			printf(" %d",amt[i]);
		}
		printf("\n");
	}
};
